/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/path/maneuver-genom3/work/templates/ros/client/ros/maneuver/srv/connect_port.srv
 *
 */


#ifndef MANEUVER_MESSAGE_CONNECT_PORTREQUEST_H
#define MANEUVER_MESSAGE_CONNECT_PORTREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace maneuver
{
template <class ContainerAllocator>
struct connect_portRequest_
{
  typedef connect_portRequest_<ContainerAllocator> Type;

  connect_portRequest_()
    : local()
    , remote()  {
    }
  connect_portRequest_(const ContainerAllocator& _alloc)
    : local(_alloc)
    , remote(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _local_type;
  _local_type local;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _remote_type;
  _remote_type remote;




  typedef boost::shared_ptr< ::maneuver::connect_portRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::maneuver::connect_portRequest_<ContainerAllocator> const> ConstPtr;

}; // struct connect_portRequest_

typedef ::maneuver::connect_portRequest_<std::allocator<void> > connect_portRequest;

typedef boost::shared_ptr< ::maneuver::connect_portRequest > connect_portRequestPtr;
typedef boost::shared_ptr< ::maneuver::connect_portRequest const> connect_portRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::maneuver::connect_portRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::maneuver::connect_portRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace maneuver

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'maneuver': ['maneuver/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::connect_portRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::connect_portRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::connect_portRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::connect_portRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::connect_portRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::connect_portRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::maneuver::connect_portRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "6e55028c71f6e37325d81ffd64dca28d";
  }

  static const char* value(const ::maneuver::connect_portRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x6e55028c71f6e373ULL;
  static const uint64_t static_value2 = 0x25d81ffd64dca28dULL;
};

template<class ContainerAllocator>
struct DataType< ::maneuver::connect_portRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "maneuver/connect_portRequest";
  }

  static const char* value(const ::maneuver::connect_portRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::maneuver::connect_portRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
string local\n\
string remote\n\
";
  }

  static const char* value(const ::maneuver::connect_portRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::maneuver::connect_portRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.local);
      stream.next(m.remote);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct connect_portRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::maneuver::connect_portRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::maneuver::connect_portRequest_<ContainerAllocator>& v)
  {
    s << indent << "local: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.local);
    s << indent << "remote: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.remote);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MANEUVER_MESSAGE_CONNECT_PORTREQUEST_H
