/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/path/maneuver-genom3/work/templates/ros/client/ros/maneuver/msg/genom_state_rusage.msg
 *
 */


#ifndef MANEUVER_MESSAGE_GENOM_STATE_RUSAGE_H
#define MANEUVER_MESSAGE_GENOM_STATE_RUSAGE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <maneuver/genom_state_stats.h>
#include <maneuver/genom_state_stats.h>

namespace maneuver
{
template <class ContainerAllocator>
struct genom_state_rusage_
{
  typedef genom_state_rusage_<ContainerAllocator> Type;

  genom_state_rusage_()
    : cycles(0)
    , timings()
    , load()  {
    }
  genom_state_rusage_(const ContainerAllocator& _alloc)
    : cycles(0)
    , timings(_alloc)
    , load(_alloc)  {
    }



   typedef uint32_t _cycles_type;
  _cycles_type cycles;

   typedef  ::maneuver::genom_state_stats_<ContainerAllocator>  _timings_type;
  _timings_type timings;

   typedef  ::maneuver::genom_state_stats_<ContainerAllocator>  _load_type;
  _load_type load;




  typedef boost::shared_ptr< ::maneuver::genom_state_rusage_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::maneuver::genom_state_rusage_<ContainerAllocator> const> ConstPtr;

}; // struct genom_state_rusage_

typedef ::maneuver::genom_state_rusage_<std::allocator<void> > genom_state_rusage;

typedef boost::shared_ptr< ::maneuver::genom_state_rusage > genom_state_rusagePtr;
typedef boost::shared_ptr< ::maneuver::genom_state_rusage const> genom_state_rusageConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::maneuver::genom_state_rusage_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::maneuver::genom_state_rusage_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace maneuver

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'maneuver': ['maneuver/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::genom_state_rusage_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::genom_state_rusage_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::genom_state_rusage_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::genom_state_rusage_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::genom_state_rusage_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::genom_state_rusage_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::maneuver::genom_state_rusage_<ContainerAllocator> >
{
  static const char* value()
  {
    return "9320d7fd882241a75db2adb6f1c2cacb";
  }

  static const char* value(const ::maneuver::genom_state_rusage_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x9320d7fd882241a7ULL;
  static const uint64_t static_value2 = 0x5db2adb6f1c2cacbULL;
};

template<class ContainerAllocator>
struct DataType< ::maneuver::genom_state_rusage_<ContainerAllocator> >
{
  static const char* value()
  {
    return "maneuver/genom_state_rusage";
  }

  static const char* value(const ::maneuver::genom_state_rusage_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::maneuver::genom_state_rusage_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::genom::state::rusage\n\
uint32 cycles\n\
genom_state_stats timings\n\
genom_state_stats load\n\
\n\
================================================================================\n\
MSG: maneuver/genom_state_stats\n\
# IDL struct ::genom::state::stats\n\
float32 last\n\
float32 max\n\
float32 avg\n\
";
  }

  static const char* value(const ::maneuver::genom_state_rusage_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::maneuver::genom_state_rusage_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.cycles);
      stream.next(m.timings);
      stream.next(m.load);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct genom_state_rusage_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::maneuver::genom_state_rusage_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::maneuver::genom_state_rusage_<ContainerAllocator>& v)
  {
    s << indent << "cycles: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.cycles);
    s << indent << "timings: ";
    s << std::endl;
    Printer< ::maneuver::genom_state_stats_<ContainerAllocator> >::stream(s, indent + "  ", v.timings);
    s << indent << "load: ";
    s << std::endl;
    Printer< ::maneuver::genom_state_stats_<ContainerAllocator> >::stream(s, indent + "  ", v.load);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MANEUVER_MESSAGE_GENOM_STATE_RUSAGE_H
