/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/path/maneuver-genom3/work/templates/ros/client/ros/maneuver/srv/set_bounds.srv
 *
 */


#ifndef MANEUVER_MESSAGE_SET_BOUNDSREQUEST_H
#define MANEUVER_MESSAGE_SET_BOUNDSREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace maneuver
{
template <class ContainerAllocator>
struct set_boundsRequest_
{
  typedef set_boundsRequest_<ContainerAllocator> Type;

  set_boundsRequest_()
    : xmin(0.0)
    , xmax(0.0)
    , ymin(0.0)
    , ymax(0.0)
    , zmin(0.0)
    , zmax(0.0)
    , yawmin(0.0)
    , yawmax(0.0)  {
    }
  set_boundsRequest_(const ContainerAllocator& _alloc)
    : xmin(0.0)
    , xmax(0.0)
    , ymin(0.0)
    , ymax(0.0)
    , zmin(0.0)
    , zmax(0.0)
    , yawmin(0.0)
    , yawmax(0.0)  {
    }



   typedef double _xmin_type;
  _xmin_type xmin;

   typedef double _xmax_type;
  _xmax_type xmax;

   typedef double _ymin_type;
  _ymin_type ymin;

   typedef double _ymax_type;
  _ymax_type ymax;

   typedef double _zmin_type;
  _zmin_type zmin;

   typedef double _zmax_type;
  _zmax_type zmax;

   typedef double _yawmin_type;
  _yawmin_type yawmin;

   typedef double _yawmax_type;
  _yawmax_type yawmax;




  typedef boost::shared_ptr< ::maneuver::set_boundsRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::maneuver::set_boundsRequest_<ContainerAllocator> const> ConstPtr;

}; // struct set_boundsRequest_

typedef ::maneuver::set_boundsRequest_<std::allocator<void> > set_boundsRequest;

typedef boost::shared_ptr< ::maneuver::set_boundsRequest > set_boundsRequestPtr;
typedef boost::shared_ptr< ::maneuver::set_boundsRequest const> set_boundsRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::maneuver::set_boundsRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::maneuver::set_boundsRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace maneuver

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'maneuver': ['maneuver/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::set_boundsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::set_boundsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::set_boundsRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::set_boundsRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::set_boundsRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::set_boundsRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::maneuver::set_boundsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "23307e656e2c9bc3927b7b12bee896da";
  }

  static const char* value(const ::maneuver::set_boundsRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x23307e656e2c9bc3ULL;
  static const uint64_t static_value2 = 0x927b7b12bee896daULL;
};

template<class ContainerAllocator>
struct DataType< ::maneuver::set_boundsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "maneuver/set_boundsRequest";
  }

  static const char* value(const ::maneuver::set_boundsRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::maneuver::set_boundsRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
float64 xmin\n\
float64 xmax\n\
float64 ymin\n\
float64 ymax\n\
float64 zmin\n\
float64 zmax\n\
float64 yawmin\n\
float64 yawmax\n\
";
  }

  static const char* value(const ::maneuver::set_boundsRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::maneuver::set_boundsRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.xmin);
      stream.next(m.xmax);
      stream.next(m.ymin);
      stream.next(m.ymax);
      stream.next(m.zmin);
      stream.next(m.zmax);
      stream.next(m.yawmin);
      stream.next(m.yawmax);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct set_boundsRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::maneuver::set_boundsRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::maneuver::set_boundsRequest_<ContainerAllocator>& v)
  {
    s << indent << "xmin: ";
    Printer<double>::stream(s, indent + "  ", v.xmin);
    s << indent << "xmax: ";
    Printer<double>::stream(s, indent + "  ", v.xmax);
    s << indent << "ymin: ";
    Printer<double>::stream(s, indent + "  ", v.ymin);
    s << indent << "ymax: ";
    Printer<double>::stream(s, indent + "  ", v.ymax);
    s << indent << "zmin: ";
    Printer<double>::stream(s, indent + "  ", v.zmin);
    s << indent << "zmax: ";
    Printer<double>::stream(s, indent + "  ", v.zmax);
    s << indent << "yawmin: ";
    Printer<double>::stream(s, indent + "  ", v.yawmin);
    s << indent << "yawmax: ";
    Printer<double>::stream(s, indent + "  ", v.yawmax);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MANEUVER_MESSAGE_SET_BOUNDSREQUEST_H
