/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/path/maneuver-genom3/work/templates/ros/client/ros/maneuver/srv/set_velocity.srv
 *
 */


#ifndef MANEUVER_MESSAGE_SET_VELOCITYREQUEST_H
#define MANEUVER_MESSAGE_SET_VELOCITYREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace maneuver
{
template <class ContainerAllocator>
struct set_velocityRequest_
{
  typedef set_velocityRequest_<ContainerAllocator> Type;

  set_velocityRequest_()
    : v(0.0)
    , w(0.0)  {
    }
  set_velocityRequest_(const ContainerAllocator& _alloc)
    : v(0.0)
    , w(0.0)  {
    }



   typedef double _v_type;
  _v_type v;

   typedef double _w_type;
  _w_type w;




  typedef boost::shared_ptr< ::maneuver::set_velocityRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::maneuver::set_velocityRequest_<ContainerAllocator> const> ConstPtr;

}; // struct set_velocityRequest_

typedef ::maneuver::set_velocityRequest_<std::allocator<void> > set_velocityRequest;

typedef boost::shared_ptr< ::maneuver::set_velocityRequest > set_velocityRequestPtr;
typedef boost::shared_ptr< ::maneuver::set_velocityRequest const> set_velocityRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::maneuver::set_velocityRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::maneuver::set_velocityRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace maneuver

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'maneuver': ['maneuver/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::set_velocityRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::set_velocityRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::set_velocityRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::set_velocityRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::set_velocityRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::set_velocityRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::maneuver::set_velocityRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "e63966e769215a305e1aebe679281346";
  }

  static const char* value(const ::maneuver::set_velocityRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xe63966e769215a30ULL;
  static const uint64_t static_value2 = 0x5e1aebe679281346ULL;
};

template<class ContainerAllocator>
struct DataType< ::maneuver::set_velocityRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "maneuver/set_velocityRequest";
  }

  static const char* value(const ::maneuver::set_velocityRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::maneuver::set_velocityRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
float64 v\n\
float64 w\n\
";
  }

  static const char* value(const ::maneuver::set_velocityRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::maneuver::set_velocityRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.v);
      stream.next(m.w);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct set_velocityRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::maneuver::set_velocityRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::maneuver::set_velocityRequest_<ContainerAllocator>& v)
  {
    s << indent << "v: ";
    Printer<double>::stream(s, indent + "  ", v.v);
    s << indent << "w: ";
    Printer<double>::stream(s, indent + "  ", v.w);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MANEUVER_MESSAGE_SET_VELOCITYREQUEST_H
