/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/path/maneuver-genom3/work/templates/ros/client/ros/maneuver/msg/waypointGoal.msg
 *
 */


#ifndef MANEUVER_MESSAGE_WAYPOINTGOAL_H
#define MANEUVER_MESSAGE_WAYPOINTGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace maneuver
{
template <class ContainerAllocator>
struct waypointGoal_
{
  typedef waypointGoal_<ContainerAllocator> Type;

  waypointGoal_()
    : x(0.0)
    , y(0.0)
    , z(0.0)
    , yaw(0.0)
    , vx(0.0)
    , vy(0.0)
    , vz(0.0)
    , wz(0.0)
    , ax(0.0)
    , ay(0.0)
    , az(0.0)  {
    }
  waypointGoal_(const ContainerAllocator& _alloc)
    : x(0.0)
    , y(0.0)
    , z(0.0)
    , yaw(0.0)
    , vx(0.0)
    , vy(0.0)
    , vz(0.0)
    , wz(0.0)
    , ax(0.0)
    , ay(0.0)
    , az(0.0)  {
    }



   typedef double _x_type;
  _x_type x;

   typedef double _y_type;
  _y_type y;

   typedef double _z_type;
  _z_type z;

   typedef double _yaw_type;
  _yaw_type yaw;

   typedef double _vx_type;
  _vx_type vx;

   typedef double _vy_type;
  _vy_type vy;

   typedef double _vz_type;
  _vz_type vz;

   typedef double _wz_type;
  _wz_type wz;

   typedef double _ax_type;
  _ax_type ax;

   typedef double _ay_type;
  _ay_type ay;

   typedef double _az_type;
  _az_type az;




  typedef boost::shared_ptr< ::maneuver::waypointGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::maneuver::waypointGoal_<ContainerAllocator> const> ConstPtr;

}; // struct waypointGoal_

typedef ::maneuver::waypointGoal_<std::allocator<void> > waypointGoal;

typedef boost::shared_ptr< ::maneuver::waypointGoal > waypointGoalPtr;
typedef boost::shared_ptr< ::maneuver::waypointGoal const> waypointGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::maneuver::waypointGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::maneuver::waypointGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace maneuver

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'maneuver': ['maneuver/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::waypointGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::maneuver::waypointGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::waypointGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maneuver::waypointGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::waypointGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maneuver::waypointGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::maneuver::waypointGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "7570ed425ee266df25caadca3060318a";
  }

  static const char* value(const ::maneuver::waypointGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x7570ed425ee266dfULL;
  static const uint64_t static_value2 = 0x25caadca3060318aULL;
};

template<class ContainerAllocator>
struct DataType< ::maneuver::waypointGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "maneuver/waypointGoal";
  }

  static const char* value(const ::maneuver::waypointGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::maneuver::waypointGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# service waypoint\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 yaw\n\
float64 vx\n\
float64 vy\n\
float64 vz\n\
float64 wz\n\
float64 ax\n\
float64 ay\n\
float64 az\n\
";
  }

  static const char* value(const ::maneuver::waypointGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::maneuver::waypointGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.x);
      stream.next(m.y);
      stream.next(m.z);
      stream.next(m.yaw);
      stream.next(m.vx);
      stream.next(m.vy);
      stream.next(m.vz);
      stream.next(m.wz);
      stream.next(m.ax);
      stream.next(m.ay);
      stream.next(m.az);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct waypointGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::maneuver::waypointGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::maneuver::waypointGoal_<ContainerAllocator>& v)
  {
    s << indent << "x: ";
    Printer<double>::stream(s, indent + "  ", v.x);
    s << indent << "y: ";
    Printer<double>::stream(s, indent + "  ", v.y);
    s << indent << "z: ";
    Printer<double>::stream(s, indent + "  ", v.z);
    s << indent << "yaw: ";
    Printer<double>::stream(s, indent + "  ", v.yaw);
    s << indent << "vx: ";
    Printer<double>::stream(s, indent + "  ", v.vx);
    s << indent << "vy: ";
    Printer<double>::stream(s, indent + "  ", v.vy);
    s << indent << "vz: ";
    Printer<double>::stream(s, indent + "  ", v.vz);
    s << indent << "wz: ";
    Printer<double>::stream(s, indent + "  ", v.wz);
    s << indent << "ax: ";
    Printer<double>::stream(s, indent + "  ", v.ax);
    s << indent << "ay: ";
    Printer<double>::stream(s, indent + "  ", v.ay);
    s << indent << "az: ";
    Printer<double>::stream(s, indent + "  ", v.az);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MANEUVER_MESSAGE_WAYPOINTGOAL_H
